#!/usr/bin/python
# Tcp Chat server
 
import socket, select, sys, time

bbsname="Cyberia BBS"

server_version="Mystic Relay Chat Server v0.10"

time_loop = 1

def broadcast_data (message):
   for socket in connection_list:
        if socket != server_socket :
			try :
				socket.send(message)
			except :
				connection_list.remove(socket)
				socket.close()
 
if __name__ == "__main__":

	if(len(sys.argv) < 2) :
		print "Usage : mrc_server.py port"
		sys.exit()
     
	PORT = int(sys.argv[1])
	connection_list = []
	RECV_BUFFER = 2048 # Advisable to keep it as an exponent of 2
	connection_list = []

	server_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	server_socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	server_socket.bind(("0.0.0.0", PORT))
	server_socket.listen(20)
 
	# Add server socket to the list of readable connections
	connection_list.append(server_socket)
 
	print "Mystic Relat Chat server started on port " + str(PORT)

	running=1 
	while running:
		read_sockets,write_sockets,error_sockets = select.select(connection_list,[],[],1)
 
		for sock in read_sockets:
			if sock == server_socket:
				# Handle the case in which there is a new connection recieved through server_socket
				sockfd, addr = server_socket.accept()
				BIP,BPORT=(addr)
				connection_list.append(sockfd)
				data = sockfd.recv(RECV_BUFFER)
				if data:
					localtime=time.asctime(time.localtime(time.time()))
					print "%s : Client (%s)[%s] connected" % (localtime,data,addr)
				sockfd.send(str(sockfd.fileno()))
             
			else:
				try:
					data = sock.recv(RECV_BUFFER)
					if data:
						if "CQUIT" in data:
							connection_list.remove(sock)
							sock.close()
							print "%d connected BBSes" % len(connection_list)
						else:
							broadcast_data(data)
   	              
				except :
					localtime=time.asctime(time.localtime(time.time()))
					BIP,BPO=(addr)
					print "%s : Client (%s) is offline" % (localtime,BIP)
					sys.stdout.flush()
					if sock in connection_list:
						connection_list.remove(sock)
						sock.close()
					continue
			time.sleep(1)
   	  
	server_socket.close()
